
#include "DSP2833x_Device.h"
#include "DSP2833x_Examples.h"
#include "math.h"


////
/////////////////////////////////////////////////
//clock setting of ADC

#define ADC_MODCLK 0x5 // sysclk/(2*5)=15MHZ




#define ls 1024

#define hann_order 32       // the order of FIR filters
#define morl_order 16       // the order of wavelet coeficients
#define value_length hann_order+ls-1        // convolution results of filter
#define value_length2 morl_order+ls-1      // convolution results of wavelet
#define cnst 32                             
#define r_thd 14                            
#define thd1  244                             
#define thd2  228                            
#define spnum 4                             
#define coef_imp 1                  // the coeficient of volt
Uint32 stop_pulse=50000L;
Uint32 stop_df=50000L;
Uint16 SampleTable[ls];   // the acquried value
float ecg_ave[ls]={0};        
float imp_ave[ls]={0};       
float ecg_morl[ls]={0};       // the  wavelet transform
float imp_breath[ls]={0};    
float imp_ecg[ls]={0};      

 int flag=1;               // variable
 int C_dir=0;                   // variable


float yy[value_length];                     // convolution result array
float yy2[value_length2]; 

float A1[4][2*cnst+1];                       
float A_ave[2*cnst+1];                          
float y_beat=0;
int x_beat=0;
int amsa=0;                                          // amsa
int pmd=0;                                            //pmd
float max_breath=0;           
float max_ecg=0;              
float *ave_e1=&A1[0][0];
float A_temp[2*cnst+1];
float r_temp[4*cnst+1];
float r[5][4*cnst+1];
float F[spnum]={0};

float   max_F=0;                
int     ave_F=0;                   

///LCD setting
#define	  LCD_DATA	(*((volatile  Uint16 *)0x45EF))
#define	  EN 	GpioDataRegs.GPBDAT.bit.GPIO60
#define	  RS 	GpioDataRegs.GPADAT.bit.GPIO12
#define	  RW 	GpioDataRegs.GPBDAT.bit.GPIO61
#define  LOW  0
#define  HIGH 1
#define CLEAR_SCREEN	0x01		//ָACֵΪ00H
#define AC_INIT			0x02		//ACΪ00HαƵԭλ
#define FUN_MODE		0x30		//ģʽ8λָ
#define DISPLAY_ON		0x0c		//ʾ,ʾα꣬αλ÷
#define sr_tl 4000   //time length

extern char Num[]={"0123456789"}; // the number from 0-9
extern void DSP28x_usDelay(unsigned long count);
void LcdInit();
void WriteCmd12864(Uint16 cmd);	
void WriteData12864(Uint16 dat);
void delay (Uint16 t);
void configtestled(void);
void DisplayCgrom(char *hz,Uint16 sp);
//void delay_s(Uint16 t);

void display_LCD(Uint16 i,int L,int adrs);
void hex_dec(Uint16 *hex_value,float *ave_value);
void corre(float *x,int m,float *y,int n,float *z,int l);
	char dis_cha[4];                 // the displayed value of residual,amsa,pmd

	char str1[8]={"Residual"};                  
	char str2[8]={"PulsStop"};            
	char str3[8]={"goPC"};               
             
	char str10[4]={"Obsv"};              
	char str11[4]={"PlVT"};              
	char str12[4]={"Asph"};             
	char str13[4]={"PEA."};                
	char str14[4]={"AMSA"};                 
	char str15[4]={"PMD:"};                 
	char str16[4]={"DFsg"};                  
	char str17[4]={"beat"};
    
#define dis_leng  4
#define str1_leng 4
#define str2_leng 8  
#define pi  3.1415926   

	

float B_low[3]={                  // B_low and A_low for 2 order butterworth
   6.100617875806e-005,            // lowpass , sample rate 400hz, cut off freq 1hz
   0.0001220123575161,
   6.100617875806e-005
   };
float A_low[3] = {
                   1,
                   -1.977786483777, 
                    0.9780305084918
                };
float B_high[3]=                           //B_high and A_high for 2 order butter
	{    0.9780304792066,                  //highpass,sample rate400hz,cut off freq 2hz
             -1.956060958413,
             0.9780304792066
       };
float A_high[3]=
       {
	     1, 
	     -1.955578240315,
	      0.9565436765112
	  };



float hann_high[hann_order]=          // highpass 1Hz with 250 sampling rate
{
	
	-0,
  -0.0002099290809401,
  -0.000900961931143,
  -0.002170424210835,
  -0.004126030624856,
  -0.006892639138454,
  -0.01062453466806,
  -0.01552763573638,
   -0.02190063366562,
   -0.03021509521949,
   -0.04128363613869,
   -0.05665253111315,
   -0.07966680139306, 
   -0.1190895860773, 
   -0.2071940492398, 
   -0.6349388070847,
     0.6349388070847, 
     0.2071940492398, 
     0.1190895860773, 
     0.07966680139306,
    0.05665253111315, 
    0.04128363613869, 
    0.03021509521949, 
    0.02190063366562,
    0.01552763573638,
    0.01062453466806,
    0.006892639138454,
    0.004126030624856,
   0.002170424210835, 
   0.000900961931143,
   0.0002099290809401, 
   0

   };

float hann_band[hann_order]=         // bandpass 5-25hz with 250hz sampling rate
{
	 -0,
     -0.0001624590360823,
     -0.0001917762013641, 
     0,
  -0.0008640245105779,
  -0.005162470429435, 
  -0.01484977381279, 
  -0.02935537431593,
   -0.04421539610957,
   -0.05163093631264,
   -0.04324606668963, 
   -0.0141767704741,
    0.03360011126437,
    0.09038818784136, 
    0.1412975394708,  
    0.1714011022394,
     0.1714011022394, 
     0.1412975394708, 
     0.09038818784136,
     0.03360011126437,
    -0.0141767704741, 
    -0.04324606668963,
    -0.05163093631264,
    -0.04421539610957,
   -0.02935537431593, 
   -0.01484977381279,
   -0.005162470429435,
   -0.0008640245105779,
     0,
     -0.0001917762013641,
     -0.0001624590360823, 
     -0
};

float morl[morl_order]=           // the wavelet morlet coeficients 16 order
{
	-0.00633902668220455,
    0.0232069650184067,
    0.000295598114633446,
    -0.135436568745518,
    0.212529383052245,
    0.129231009077540,
    -0.621114156819625,
    0.397798794951816,
    0.397798794951816,
    -0.621114156819625,
    0.129231009077540,
    0.212529383052245,
    -0.135436568745518,
    0.000295598114633446,
    0.0232069650184067,
    -0.00633902668220455
};
//////////////////////////////////////////////////////
int NL=ls;
struct Complex		// 帴ṹ
{
   float real,imag;
};
struct Complex Wn;//ת
struct Complex Vn;//ÿһһת鲿Ϊ0ʵΪ1
struct Complex T;//תX(k+B)ĳ˻

//float Realin[NL]={0};// ʵ
float output[ls]={0};// FFTֵģ
struct Complex Sample[ls];// ʵתΪ

struct Complex MUL(struct Complex a,struct Complex b)//帴
{
   struct Complex c;
   c.real=a.real*b.real-a.imag*b.imag;
   c.imag=a.real*b.imag+a.imag*b.real;
   return(c);
}

void MYFFT(struct Complex *xin,int N)//Ϊָ*xinNFFT
{
   int L=0; // 
   int J=0; // 
   int K=0,KB=0; // 
   int M=1,Nn=0;// N=2^M
   float B=0; // ݼ
   /* Ϊ½ľֲ*/
   int LH=0,J2=0,N1=0,I,K2=0;
   struct Complex T;
   /*ǵ*/
   LH=N/2; // LH=N/2
   J2=LH;
   N1=N-2;
   for(I=1;I<=N1;I++)
    {
     if(I<J2)
	 {
       T=xin[I];
       xin[I]=xin[J2];
       xin[J2]=T;
	 }
	 K2=LH;
	 while(J2>=K2)
	  {
        J2-=K2;
        K2=K2/2;// K2=K2/2
	  }
	  J2+=K2;
    }	    
   /* ΪM */
   Nn=N;
   while(Nn!=2)// N2ΪM
   {
     M++;
	 Nn=Nn/2;
   }

   /*  */
   for(L=1;L<=M;L++)  // 
	{
	  B=pow(2,(L-1));
      Vn.real=1;
	  Vn.imag=0;
      Wn.real=cos(pi/B);
      Wn.imag=-sin(pi/B);
	  for(J=0;J<B;J++)   // 
	   {        
		 for(K=J;K<N;K+=2*B)  // 
		  {
            KB=K+B;
            T=MUL(xin[KB],Vn);
            xin[KB].real=xin[K].real-T.real;//ԭַ㣬ԭ
            xin[KB].imag=xin[K].imag-T.imag;
             xin[K].real=xin[K].real+T.real;
             xin[K].imag=xin[K].imag+T.imag;      
		  }
		  Vn=MUL(Wn,Vn);// ת൱ָӣõĽ
		  // J*2^M-LһģΪڵ
		 // MLǲģΨһxǼڵJ
		 // J1ΪģJ*WЧW+W+W...JW
		}
	 }
}

/********************************
ܣ㸴ģ
βΣ*SampleָҪȡģĸṹ
      NΪȡģ
	  *outputȡģֵ
*********************************/
void ModelComplex(struct Complex *Sample,int N,float *output)
{
   int i;
   for(i=0;i<N;i++)
    {

     output[i]=sqrt(Sample[i].real*Sample[i].real+Sample[i].imag*Sample[i].imag)*2/N;
	}
}

//////////////////////////////////////////////////////////////////////////////////////////

void LinearConvolution(int xn,int hn,float *x,float *h,float *y)  // the linear convolution
{
   int i,j,k,l;
   int yn;   //yĳ
   yn=xn+hn-1;
   for(i=0;i<yn;i++) y[i]=0;  //ʼ
   k=yn-1;
   for(i=hn-1;i>0;i--)      //*hΪ
    {
       l=k;
       for(j=xn-1;j>0;j--)  //x[n]1~(xn-1)h[i]һ
	    {
           y[l]+=h[i]*x[j];
		   l--;
		}
	   y[l]+=x[0]*h[i];     
	   k--;
	}
	l=k;
   for(j=xn-1;j>0;j--)
	{
       y[l]+=h[0]*x[j];
	   l--;
    }
	y[l]+=x[0]*h[0];
}  

///////////////////////////main 


void main(void)
{
	Uint16 array_index=0;
	int index=0;
    int k_rs;
  
    int m_breath=0;
	int m_ecg=0;

	int pulse_p=0;               
	int tidal_v=0;                 
    Uint16 i,j;    // variable

void qrsdect(float *data,int num,float *ave_e1);                                    // for residual calculation
void imp_filter(float *datain,float *B, float *A, float *sample_filtered);         // the filter for impednace
void amsa_pmd(float *ecg_data,float *module_ap,int ls_ap);
void diagnose_imp(int pulse,int tidal);
void Lcd_default();
	InitSysCtrl();
//	InitXintf();

	InitGpio();
	InitXintf16Gpio();
	EALLOW;
	SysCtrlRegs.HISPCP.all=ADC_MODCLK;////////clock preset for ADC clock
	EDIS;

	DINT;

	InitPieCtrl();
	IER=0x0000;
	IFR=0x0000;

	InitPieVectTable();
    memcpy(&RamfuncsRunStart,&RamfuncsLoadStart,(&RamfuncsLoadEnd - &RamfuncsLoadStart));
	InitFlash();


	/////////////////*************************/////////////////////////////////
	////LCD 
	configtestled();
   RS=LOW;
    delay(5);
   RW=LOW;
    delay(5);
   EN=LOW;
    
   LcdInit();
   Lcd_default();  // display the default setting

//////////////////////////////////////////////////////////////
////////////////////////////////////////////////InitAdc
	InitAdc();

	AdcRegs.ADCTRL3.bit.ADCCLKPS=0x00;

	AdcRegs.ADCTRL1.bit.ACQ_PS=0x01; //adclk/(1+1+1)=15/3=7.5MHz

	AdcRegs.ADCTRL1.bit.SEQ_CASC = 1;        // 1  Cascaded mode
	AdcRegs.ADCTRL3.bit.SMODE_SEL=0;       // sequence sampling
   AdcRegs.ADCCHSELSEQ1.bit.CONV00 = 0x00;

   AdcRegs.ADCTRL1.bit.CONT_RUN = 1;       // Setup continuous run

   AdcRegs.ADCTRL1.bit.SEQ_OVRD = 1;       // Enable Sequencer override feature
  
   AdcRegs.ADCMAXCONV.bit.MAX_CONV1 = 0x00;


	for (i=0;i<ls;i++)
	{
		SampleTable[i]=0;
	
	}

///////////////////////////////////////////////////////

	AdcRegs.ADCTRL2.all=0x2000;
	
	for (;;)
	{
		while(AdcRegs.ADCST.bit.INT_SEQ1==0)
		{}
	
		AdcRegs.ADCST.bit.INT_SEQ1_CLR=1;

	SampleTable[array_index++]=((AdcRegs.ADCRESULT0)>>4);

	
		DELAY_US(sr_tl);    //the sample rate is 250hz
 
		if (array_index>=ls) 
		{
			array_index=0;
		
       	 	 if (flag==1)
			 {
                     
           			 hex_dec(SampleTable,ecg_ave);
          			LinearConvolution(ls,hann_order,ecg_ave,hann_high,yy);  // convolution for highpass

         			for(index=0;index<ls;index++)
					{
	    			ecg_ave[index]=yy[index];
					}

					LinearConvolution(ls,hann_order,ecg_ave,hann_band,yy);  // convolution for bandpass

					for(index=0;index<ls;index++)
					{
						ecg_ave[index]=yy[index];
					}

					LinearConvolution(ls,morl_order,ecg_ave,morl,yy2);   // convolution for wavelet

					for(index=0;index<ls;index++)
					{
						ecg_morl[index]=yy2[index]*1000;
					}

          			 qrsdect(ecg_morl,cnst,ave_e1);

		   			for(index=0;index<2*cnst+1;index++)
   					{
    	 			 A_ave[index]=(A1[0][index]+A1[1][index]+A1[2][index]+A1[3][index])/4; 
  					 }

  					for(j=0;j<spnum;j++)
  				 	{

						for(index=0;index<2*cnst+1;index++)
						{
							A_temp[index]=A1[j][index];
						}
       					 corre(A_temp,2*cnst+1,A_ave,2*cnst+1,r_temp,4*cnst+1);
						for(index=0;index<4*cnst+1;index++)
						{
						r[j][index]=r_temp[index];
						}
  					}
      
 					  corre(A_ave,2*cnst+1,A_ave,2*cnst+1,r_temp,4*cnst+1);

  				 	for(index=0;index<4*cnst+1;index++)
					{
						r[spnum][index]=r_temp[index];
					}



  			 		for(j=0;j<spnum;j++)
  			 		{
	 	 		  		F[j]=0;
     	 		 		for(index=0;index<4*cnst+1;index++)
	  			 		{
				 		 F[j]= fabs(r[spnum][index]-r[j][index])+F[j];

	 	 		 		}
	 	 	
  					 }

						 max_F=0;
						 C_dir=0;
   			 		for(j=0;j<spnum;j++)
					{
						if (F[j]<r_thd)
						{C_dir++;
							max_F=F[j]+max_F;
						}

					}
				ave_F=(int)(max_F*10/C_dir+0.5);
			    	 LcdInit();
                      Lcd_default();  // display the default setting
		
					if (C_dir>=3)
					{
		 	    		if (ave_F>999||ave_F<0)  //the value should be significant
				  		{ave_F=0;}

		 	    		display_LCD(ave_F,0,0x85);
		 	    
		 				WriteCmd12864(0x92);
            	 		delay(5);
            			DisplayCgrom(str2,str2_leng);
                 
                		DELAY_US(stop_pulse);
		 				 k_rs=1; 
		 			 
					}

	
					if (C_dir<3)
					{
           				 C_dir=0;
						 max_F=0;
           				for(j=0;j<spnum;j++)
						{
							if (F[j]>r_thd)
							{  C_dir++;
							max_F=F[j]+max_F;
							}

						}
						ave_F=(int)(max_F*10/C_dir+0.5);

           			if (ave_F>999||ave_F<0)  //the value should be significant
				 	 	{ave_F=0;}
           			
           			display_LCD(ave_F,0,0x85);
					WriteCmd12864(0x92);
            	 	delay(5);
            		DisplayCgrom(str3,str1_leng);
					delay(5);

           			 k_rs=0;
					 
            	 	for(i=0;i<ls;i++)   //ʵźתΪ
	            	{
                  	 Sample[i].real=ecg_ave[i];
	        
	            	 Sample[i].imag=0;
	            	 }
				 		MYFFT(Sample,ls);                //FFT
    					 ModelComplex(Sample,ls,output);  //ģ
						 amsa_pmd(ecg_ave,output,ls);
                 
                	WriteCmd12864(0x88);
 	                delay(5);
                	DisplayCgrom(str14,str1_leng);
					display_LCD(amsa,0,0x8A);

					WriteCmd12864(0x8C);
 	                delay(5);
                	DisplayCgrom(str15,str1_leng);
					display_LCD(pmd,0,0x8E);


                 	if (amsa>=200)
					 {	WriteCmd12864(0x9A);
 	               		 delay(5);
                		DisplayCgrom(str16,str1_leng);
						delay(5);
						DELAY_US(4000);
						
						}

				 	if(amsa<200)
				 	{	WriteCmd12864(0x9A);
 	               		 delay(5);
                		DisplayCgrom(str3,str1_leng);
						delay(5);
						DELAY_US(4000);

					}
		
	     		}
			}


		 	 if (flag==0)
			 {
			    hex_dec(SampleTable,imp_ave);
				imp_filter(imp_ave,B_low,A_low,imp_breath);
				imp_filter(imp_ave,B_high,A_high,imp_ecg);
				pulse_p=0;
				tidal_v=0;
					for(index=0;index<ls;index++)
 					{
						if(imp_breath[index]>max_breath)
						max_breath=imp_breath[index];
	   					 if(imp_ecg[index]>max_ecg)
						max_ecg=imp_ecg[index];
					}

				 		 pulse_p=max_ecg*100;// this is for test    
						tidal_v=max_breath*100;
                   if(pulse_p>999||pulse_p<0)
				   { pulse_p=0;}
				   if(tidal_v>999||tidal_v<0)
				   { tidal_v=0;}

  			 
					m_ecg=(int)(max_ecg*10+0.5); 
					m_breath=(int)(max_breath*10+0.5); 
            	   diagnose_imp(pulse_p,tidal_v);
			 	  //DELAY_US(4000);
			         
					 k_rs=0;


		 	 } 

      		 if(k_rs==1)
	 		  {
	   			  flag=0;
					AdcRegs.ADCCHSELSEQ1.bit.CONV00 = 0x08;
			  }

	 		  if(k_rs==0)
	 			 { 
	    			 flag=1;
					AdcRegs.ADCCHSELSEQ1.bit.CONV00 = 0x00;
				
				 }

       }
    }	
  

} //main

void display_LCD(Uint16 i,int L,int adrs)
{
	int m=0;
	int l=0;
	int k=0;
		

	m=i/100;
	l=(i%100)/10;
	k=(i%100)%10;
  if(L==0)
  {
	dis_cha[0]=Num[m];
	dis_cha[1]=Num[l];
	dis_cha[3]=Num[k];
	dis_cha[2]='.';
  }
  
   if(L==1)
  {
    dis_cha[0]=Num[m];
	dis_cha[1]=Num[l];
	dis_cha[2]=Num[k];
	dis_cha[3]='.';
  }
		WriteCmd12864(adrs);
 		 delay(5);
		DisplayCgrom(dis_cha,dis_leng);// if the number is between 100-1000
		delay(5);
	
 


}

void Lcd_default()    // set the default display when start 
{
 
 
 int l_lcd=0;
  int k_lcd=0;
  int m_lcd=0;	
  dis_cha[0]=Num[m_lcd];
  dis_cha[1]=Num[l_lcd];
  dis_cha[2]='.';
  dis_cha[3]=Num[k_lcd];
 
 
  

	WriteCmd12864(0x80);
 	 delay(5);
	DisplayCgrom(str1,str2_leng);
	delay(5);

		WriteCmd12864(0x85);
 	 delay(5);
	DisplayCgrom(dis_cha,dis_leng); //initilized to 000
	

  	 delay(5);
}


 void configtestled(void)                                     
 {                                                            
    EALLOW;                                                   
     GpioCtrlRegs.GPBMUX2.bit.GPIO60 = 0; // GPIO60 = GPIO60  
     GpioCtrlRegs.GPBDIR.bit.GPIO60 = 1;                      
     GpioCtrlRegs.GPBMUX2.bit.GPIO61 = 0; // GPIO60 = GPIO60  
     GpioCtrlRegs.GPBDIR.bit.GPIO61 = 1;                      
 	GpioCtrlRegs.GPAMUX1.bit.GPIO12 = 0;                        
     GpioCtrlRegs.GPADIR.bit.GPIO12 = 1;                      
                                                          
    EDIS;                                                     
 }                                                          
void delay (Uint16 t)
{ Uint16 q;
  while(t--)
  {
     for(q=0;q<512;q++)
       ;
  }
}


void LcdInit()
{
    delay(5);
	WriteCmd12864(FUN_MODE);
    delay(5);
  
//	WriteCmd12864(FUN_MODE);
//	delay(5);
 
    WriteCmd12864(DISPLAY_ON);
	delay(5);
  
 	WriteCmd12864(CLEAR_SCREEN);
	delay(5);

    WriteCmd12864(AC_INIT);
   delay(5);
  
}

void WriteCmd12864(Uint16 cmd)
{   
  //  Uint16 i=5;
    RS=LOW;			
    RW=LOW;	
    EN=HIGH;
   	LCD_DATA=cmd;
//	while(i--);	
    EN=LOW;
}
void WriteData12864(Uint16 dat)
{ // Uint16 i=5;
    RS=HIGH;
    RW=LOW;
	EN=HIGH;
    LCD_DATA=dat;
//	while(i--);	
    EN=LOW;
}

void DisplayCgrom(char *hz,Uint16 sp)
{
	while(sp!=0)
	{
		WriteData12864(*hz);
		hz++;
		sp--;
        delay(20);
	}

} 

void hex_dec(Uint16 *hex_value,float *ave_value)
{
	Uint16 index=0;
    Uint32 temp0=0;
 
	for (index=0;index<ls;index++)
	{                   
    temp0=hex_value[index];
	imp_breath[index]=temp0*3/4095.0;
	}

	ave_value[0]=imp_breath[0];
	ave_value[1]=imp_breath[1];
	ave_value[ls-1]=imp_breath[ls-1];
	ave_value[ls-2]=imp_breath[ls-2];

	for(index=2;index<ls-2;index++)
	{
	 ave_value[index]=(imp_breath[index-2]+imp_breath[index-1]+imp_breath[index]
	 +imp_breath[index+1]+imp_breath[index+2])/5;
	}

}






void amsa_pmd(float *ecg_data,float *module_ap,int ls_ap)
{
  int index=0;
  int freq1=0;
  int freq2=0;
  float y_value=0;
  int x_value=0;

  freq1=5*ls_ap/250+1;
  freq2=25*ls_ap/250;
  amsa=0;
  pmd=0;
  for(index=freq1;index<freq2+1;index++)
  {
	amsa+=(int)(module_ap[index]*10*index*250/ls_ap+0.5);

		if(module_ap[index]>y_value)
	 	 {
	 	 	 y_value=module_ap[index];
	 		  x_value=(int)(index*250/ls_ap+0.5);
	  	 }

	}

  for(index=0;index<ls_ap;index++)
  {
    pmd+=(int)(fabs(ecg_data[index])+0.5);
	}
	pmd=pmd*x_value/10;
  if(amsa>999||amsa<0)
  {  amsa=0;}
  if(pmd>999||pmd<0)
  {  pmd=0;}
  


}

void qrsdect(float *data,int num,float *ave_e1)
{
	

	int i=0,j=0;
	float work_e[ls];
	float max_work=0;
	int X=0;
	int fl=0;
    for(i=0;i<8*cnst+4;i++)
	{
	 ave_e1[i]=0;
	 }

	for(i=0;i<ls;i++)
	{
	
		work_e[i]=fabs(data[i]);
	}

	for (i=0;i<num;i++)
	{
		work_e[i]=0;
		work_e[ls-i-1]=0;
	}
	

	for(j=0;j<4;j++)
	{
		for (i=0;i<ls;i++)
		{
			if (work_e[i]>max_work)
			{	max_work=work_e[i];
			X=i;
			}
		}
		
	for (i=X-num;i<=X+num;i++)
		{
			ave_e1[i-X+num+fl]=data[i];
			work_e[i]=0;
		}
		fl=2*num*(j+1)+j+1;
		 max_work=0;
		X=0;

		
	}


}

void corre(float *x,int m,float *y,int n,float *z,int l)
{
	int i,j,k;
	float max_1=0;
	for(i=0;i<l;i++)
	{
		z[i]=0;
		k=i-(n-1);
		for(j=0;j<m;j++)
			if(j-k>=0&&j-k<n)
				z[i]+=x[j]*y[j-k];
	}
	for(i=0;i<l;i++)
	{
		if (z[i]>max_1)
			max_1=z[i];
		if (z[i]<=max_1)
			continue;
	}
	for(i=0;i<l;i++)
	{
		z[i]=z[i]/max_1;
	}


}


 void imp_filter(float *datain,float *B, float *A, float *sample_filtered)
{
	float st1=0;
    float st2=0;
	float Tmp_f1=0;
	float st=0;
	int i=0;
for(i=0;i<ls;i++)
   {
    sample_filtered[i]=0;
    st=datain[i]-A[1]*st1-A[2]*st2;
    Tmp_f1=B[0]*st+B[1]*st1+B[2]*st2;
    st2=st1;
    st1=st;
    sample_filtered[i]=Tmp_f1;
	}



}


void diagnose_imp(int pulse,int tidal)
{
	if (pulse>=thd1&&tidal>=thd2)
	{
					WriteCmd12864(0x9A);
 	                delay(20);
                	DisplayCgrom(str10,str1_leng);
					delay(36750);
	}
	   
	if (pulse<thd1&&tidal>=thd2)
	{
					WriteCmd12864(0x9A);
 	                delay(20);
                	DisplayCgrom(str11,str1_leng);
					delay(36750);
    }
	    
	if (pulse>=thd1&&tidal<thd2)
	{
					WriteCmd12864(0x9A);
 	                delay(20);
                	DisplayCgrom(str12,str1_leng);
					delay(36750);
	}
	    
	if (pulse<thd1&&tidal<thd2)
	{
					WriteCmd12864(0x9A);
 	                delay(20);
                	DisplayCgrom(str13,str1_leng);
					delay(36750);
	}
	    
}




/* void delay_s(Uint16 t) */
/* {                      */
/*   Uint16 k;            */
/*   while(t--)           */
/*   {                    */
/*     for(k=0;k<207;k++) */
/* 	;                     */
/*   }                    */
/* }                      */
